/*****************************************************************************************
 Copyright (c) 2002-2004 The UbixOS Project
 All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are
 permitted provided that the following conditions are met:

 Redistributions of source code must retain the above copyright notice, this list of
 conditions, the following disclaimer and the list of authors.  Redistributions in binary
 form must reproduce the above copyright notice, this list of conditions, the following
 disclaimer and the list of authors in the documentation and/or other materials provided
 with the distribution. Neither the name of the UbixOS Project nor the names of its
 contributors may be used to endorse or promote products derived from this software
 without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 $Id$

*****************************************************************************************/

#include <ubixos/exec.h>
#include <ubixos/sched.h>
#include <ubixos/ld.h>
#include <ubixos/kpanic.h>
#include <ubixos/endtask.h>
#include <vmm/vmm.h>
#include <lib/kmalloc.h>
#include <lib/kprintf.h>
#include <lib/string.h>
#include <assert.h>

/*****************************************************************************************

 Function:   execThread(void (*)(void),int,char *);
 Description: This function will create a thread from code in the current memory space

 Notes:
 
 05/19/04 - This does not work the way I want it to it still makes a copy of kernel space
            so do not use out side of kernel space

*****************************************************************************************/
uInt32 execThread(void (* tproc)(void),uInt32 stack,char *arg) {
  kTask_t * newProcess = 0x0;
  /* Find A New Thread */
  newProcess = schedNewTask();
  assert(newProcess); 
  if (stack < 0x100000)
    kpanic("exec: stack not in valid area: [0x%X]\n",stack);

  /* Set All The Correct Thread Attributes */
  newProcess->tss.back_link    = 0x0;
  newProcess->tss.esp0         = 0x0;
  newProcess->tss.ss0          = 0x0;
  newProcess->tss.esp1         = 0x0;
  newProcess->tss.ss1          = 0x0;
  newProcess->tss.esp2         = 0x0;
  newProcess->tss.ss2          = 0x0;
  newProcess->tss.cr3          = (unsigned int)kernelPageDirectory;
  newProcess->tss.eip          = (unsigned int)tproc;
  newProcess->tss.eflags       = 0x206;
  newProcess->tss.esp          = stack;
  newProcess->tss.ebp          = stack;
  newProcess->tss.esi          = 0x0;
  newProcess->tss.edi          = 0x0;

  newProcess->tss.es           = 0x10;
  newProcess->tss.cs           = 0x08;
  newProcess->tss.ss           = 0x10;
  newProcess->tss.ds           = 0x10;
  newProcess->tss.fs           = 0x10;
  newProcess->tss.gs           = 0x10;
  newProcess->tss.ldt          = 0x18;

  newProcess->tss.trace_bitmap = 0x0000;
  newProcess->tss.io_map       = 0x8000;
  newProcess->oInfo.vmStart    = 0x6400000;
  
  newProcess->imageFd          = 0x0;

  /* Set up default stack for thread here filled with arg list 3 times */
  asm volatile(
    "pusha               \n"
    "movl   %%esp,%%ecx  \n"
    "movl   %1,%%eax     \n"
    "movl   %%eax,%%esp  \n"
    "pushl  %%ebx        \n"
    "pushl  %%ebx        \n"
    "pushl  %%ebx        \n"
    "movl   %%esp,%%eax  \n"
    "movl   %%eax,%1     \n"
    "movl   %%ecx,%%esp  \n"
    "popa                \n"
    :
    : "b" (arg),"m" (newProcess->tss.esp)
    );

  /* Put new thread into the READY state */
  sched_setStatus(newProcess->id,READY);

  /* Return with the new process ID */
  return((uInt32)newProcess);
  }

/*****************************************************************************************

 Function: void execFile(char *file);
 Description: This Function Executes A Kile Into A New VM Space With Out
              Having To Fork
 Notes:

 07/30/02 - I Have Made Some Heavy Changes To This As Well As Fixed A Few
            Memory Leaks The Memory Allocated To Load The Binary Into Is
            Now Unmapped So It Can Be Used Again And Not Held Onto Until
            The Program Exits

 07/30/02 - Now I Have To Make A Better Memory Allocator So We Can Set Up
            The Freshly Allocated Pages With The Correct Permissions

*****************************************************************************************/
void execFile(char *file,int argc,char **argv,int console) {

  int     i      = 0x0;
  int     x      = 0x0;

  fileDescriptor   *tmpFd         = 0x0;
  elfHeader        *binaryHeader  = 0x0;
  elfProgramHeader *programHeader = 0x0;

  /* Get A New Task For This Proccess */
  _current = schedNewTask();
  assert(_current);
  _current->gid  = 0x0;
  _current->uid  = 0x0;
  _current->term = tty_find(console);
  if (_current->term == 0x0)
    kprintf("Error: invalid console\n");
    
  /* Set tty ownership */
  _current->term->owner = _current->id;

  /* Now We Must Create A Virtual Space For This Proccess To Run In */
  _current->tss.cr3 = (uInt32)vmmCreateVirtualSpace(_current->id);

  /* To Better Load This Application We Will Switch Over To Its VM Space */
  asm volatile(
    "movl %0,%%eax          \n"
    "movl %%eax,%%cr3       \n"
    : : "d" ((uInt32 *)(_current->tss.cr3))
    );

  /* Lets Find The File */
  tmpFd = fopen(file,"r");

  /* If We Dont Find the File Return */
  if (tmpFd == 0x0) {
    kprintf("Exec Format Error: Binary File Not Executable.\n");
    fclose(tmpFd);
    return;
    }
  if (tmpFd->perms == 0x0) {
    kprintf("Exec Format Error: Binary File Not Executable.\n");
    fclose(tmpFd);
    return;
    }

  /* Load ELF Header */
  binaryHeader = (elfHeader *)kmalloc(sizeof(elfHeader));


  //kprintf(">a:%i:0x%X:0x%X<",sizeof(elfHeader),binaryHeader,tmpFd);
  fread(binaryHeader,sizeof(elfHeader),1,tmpFd);


  /* Check If App Is A Real Application */
  if ((binaryHeader->eIdent[1] != 'E') && (binaryHeader->eIdent[2] != 'L') && (binaryHeader->eIdent[3] != 'F')) {
    kprintf("Exec Format Error: Binary File Not Executable.\n");
    kfree(binaryHeader);
    fclose(tmpFd);
    return;
    }
  else if (binaryHeader->eType != 2) {
    kprintf("Exec Format Error: Binary File Not Executable.\n");
    kfree(binaryHeader);
    fclose(tmpFd);
    return;
    }
  else if (binaryHeader->eEntry == 0x300000) {
    kprintf("Exec Format Error: Binary File Not Executable.\n");
    kfree(binaryHeader);
    fclose(tmpFd);
    return;
    }

  /* Load The Program Header(s) */
  programHeader = (elfProgramHeader *)kmalloc(sizeof(elfProgramHeader)*binaryHeader->ePhnum);
  fseek(tmpFd,binaryHeader->ePhoff,0);

  //kprintf(">c:%i:0x%X:0x%X<",sizeof(elfProgramHeader)*binaryHeader->ePhnum,programHeader,tmpFd);
  fread(programHeader,(sizeof(elfProgramHeader)*binaryHeader->ePhnum),1,tmpFd);
  //kprintf(">d<");

  /* Loop Through The Header And Load Sections Which Need To Be Loaded */
  for (i=0;i<binaryHeader->ePhnum;i++) {
    if (programHeader[i].phType == 1) {
      /*
      Allocate Memory Im Going To Have To Make This Load Memory With Correct
      Settings so it helps us in the future
      */
      for (x = 0x0;x < (programHeader[i].phMemsz+4095);x += 0x1000) {
        /* Make readonly and read/write !!! */
        if (vmm_remapPage(vmmFindFreePage(_current->id),((programHeader[i].phVaddr & 0xFFFFF000) + x),PAGE_DEFAULT) == 0x0)
          kpanic("Error: vmmFindFreePage Failed\n");
        memset((void *)((programHeader[i].phVaddr & 0xFFFFF000) + x),0x0,0x1000);
        }
      _current->oInfo.vmStart = ((programHeader[i].phVaddr & 0xFFFFF000) + 0x1900000);
      /* Now Load Section To Memory */
      fseek(tmpFd,programHeader[i].phOffset,0);
      fread((void *)programHeader[i].phVaddr,programHeader[i].phFilesz,1,tmpFd);
      if ((programHeader[i].phFlags & 0x2) != 0x2) {
        for (x = 0x0;x < (programHeader[i].phMemsz+4095);x += 0x1000) {
          if ((vmm_setPageAttributes((programHeader[i].phVaddr & 0xFFFFF000) + x,PAGE_PRESENT | PAGE_USER)) != 0x0)
	    kpanic("Error: vmm_setPageAttributes failed, File: %s, Line: %i\n",__FILE__,__LINE__);
	  }
        }
      }
    }

  /* Set Virtual Memory Start */
  _current->oInfo.vmStart = ((programHeader[i].phVaddr & 0xFFFFF000) + 0x1900000);

  /* Task Stack 0x2000 bytes long */
  vmm_remapPage(vmmFindFreePage(_current->id),0x5DC000,PAGE_DEFAULT | PAGE_STACK);
  vmm_remapPage(vmmFindFreePage(_current->id),0x5DB000,PAGE_DEFAULT | PAGE_STACK);

  /* Kernel Stack 0x2000 bytes long */
  vmm_remapPage(vmmFindFreePage(_current->id),0x5CC000,KERNEL_PAGE_DEFAULT | PAGE_STACK);
  vmm_remapPage(vmmFindFreePage(_current->id),0x5CB000,KERNEL_PAGE_DEFAULT | PAGE_STACK);

  /* Set All The Proper Information For The Task */
  _current->tss.back_link    = 0x0;
  _current->tss.esp0         = 0x5CC000;
  _current->tss.ss0          = 0x10;
  _current->tss.esp1         = 0x0;
  _current->tss.ss1          = 0x0;
  _current->tss.esp2         = 0x0;
  _current->tss.ss2          = 0x0;
  _current->tss.eip          = (long)binaryHeader->eEntry;
  _current->tss.eflags       = 0x206;
  _current->tss.esp          = 0x5DD000-12;
  _current->tss.ebp          = 0x5DD000;
  _current->tss.esi          = 0x0;
  _current->tss.edi          = 0x0;

  /* Set these up to be ring 3 tasks */
  _current->tss.es           = 0x30+3;
  _current->tss.cs           = 0x28+3;
  _current->tss.ss           = 0x30+3;
  _current->tss.ds           = 0x30+3;
  _current->tss.fs           = 0x30+3;
  _current->tss.gs           = 0x30+3;

  _current->tss.ldt          = 0x18;
  _current->tss.trace_bitmap = 0x0000;
  _current->tss.io_map       = 0x8000;
  
  sched_setStatus(_current->id,READY);

  kfree(binaryHeader);
  kfree(programHeader);
  fclose(tmpFd);

  /* Switch Back To The Kernels VM Space */
  asm volatile(
    "movl %0,%%eax          \n"
    "movl %%eax,%%cr3       \n"
    : : "d" ((uInt32 *)(kernelPageDirectory))
    );

  /* Finally Return */
  return;
  }

/*****************************************************************************************

 Function: void sysExec();
 Description: This Is The System Call To Execute A New Task

 Notes:
 04-22-03 - It Now Loads Sections Not The Full File

*****************************************************************************************/
void sysExec(char *file,int argc,char **argv) {
  int    i            = 0x0;
  int    x            = 0x0;
  uInt32 *tmp         = 0x0;
  uInt32  ldAddr      = 0x0;

  fileDescriptor   *tmpFd         = 0x0;
  elfHeader        *binaryHeader  = 0x0;
  elfProgramHeader *programHeader = 0x0;
  elfSectionHeader *sectionHeader = 0x0;
  elfDynamic       *elfDynamicS   = 0x0;

  tmpFd = fopen(file,"r");
  _current->imageFd = tmpFd;
  /* If We Dont Find the File Return */
  if (tmpFd == 0x0) {
    kprintf("Couldn't open file %s\n",file);
    return;
    }
  if (tmpFd->perms == 0) {
    kprintf("Exec Format Error: Binary File Not Executable.\n");
    fclose(tmpFd);
    return;
    }

  /* Load ELF Header */

  if ((binaryHeader = (elfHeader *)kmalloc(sizeof(elfHeader))) == 0x0) 
    endTask(_current->id);
    fread(binaryHeader,sizeof(elfHeader),1,tmpFd);
    /* Set sectionHeader To Point To Loaded Binary To We Can Gather Info */

  /* Check If App Is A Real Application */
  if ((binaryHeader->eIdent[1] != 'E') && (binaryHeader->eIdent[2] != 'L') && (binaryHeader->eIdent[3] != 'F')) {
    kprintf("Exec Format Error: Binary File Not Executable.\n");
    kfree(binaryHeader);
    fclose(tmpFd);

    return;
    }
  else if (binaryHeader->eType != 2) {
    kprintf("Exec Format Error: Binary File Not Executable.\n");
    kfree(binaryHeader);
    fclose(tmpFd);
    return;
    }
  else if (binaryHeader->eEntry == 0x300000) {
    kprintf("Exec Format Error: Binary File Not Executable.\n");
    kfree(binaryHeader);
    fclose(tmpFd);
    return;
    }

  /* Load The Program Header(s) */
  if ((programHeader = (elfProgramHeader *)kmalloc(sizeof(elfProgramHeader)*binaryHeader->ePhnum)) == 0x0)
    endTask(_current->id);
    
  assert(programHeader);
  fseek(tmpFd,binaryHeader->ePhoff,0);
  fread(programHeader,(sizeof(elfProgramHeader)*binaryHeader->ePhnum),1,tmpFd);

  if ((sectionHeader = (elfSectionHeader *)kmalloc(sizeof(elfSectionHeader)*binaryHeader->eShnum)) == 0x0)
    endTask(_current->id);
  
  assert(sectionHeader);
  fseek(tmpFd,binaryHeader->eShoff,0);
  fread(sectionHeader,sizeof(elfSectionHeader)*binaryHeader->eShnum,1,tmpFd);

  /* Loop Through The Header And Load Sections Which Need To Be Loaded */
  for (i=0;i<binaryHeader->ePhnum;i++) {
    if (programHeader[i].phType == 1) {
      /*
      Allocate Memory Im Going To Have To Make This Load Memory With Correct
      Settings so it helps us in the future
      */
      for (x=0;x<(programHeader[i].phMemsz+4095);x += 0x1000) {
        /* Make readonly and read/write !!! */
        if (vmm_remapPage(vmmFindFreePage(_current->id),((programHeader[i].phVaddr & 0xFFFFF000) + x),PAGE_DEFAULT) == 0x0)
          kpanic("Error: vmmFindFreePage Failed\n");
        memset((void *)((programHeader[i].phVaddr & 0xFFFFF000) + x),0x0,0x1000);
        }
      _current->oInfo.vmStart = ((programHeader[i].phVaddr & 0xFFFFF000) + 0x1900000);
      /* Now Load Section To Memory */
      fseek(tmpFd,programHeader[i].phOffset,0);
      fread((void *)programHeader[i].phVaddr,programHeader[i].phFilesz,1,tmpFd);
      if ((programHeader[i].phFlags & 0x2) != 0x2) {
        for (x = 0x0;x < (programHeader[i].phMemsz+4095);x += 0x1000) {
          if ((vmm_setPageAttributes((programHeader[i].phVaddr & 0xFFFFF000) + x,PAGE_PRESENT | PAGE_USER)) != 0x0)
	    kpanic("Error: vmm_setPageAttributes failed, File: %s,Line: %i\n",__FILE__,__LINE__);
	  }
        }
      }
    else if (programHeader[i].phType == 2) {
      //newLoc = (char *)programHeader[i].phVaddr;
      elfDynamicS = (elfDynamic *)programHeader[i].phVaddr;
      fseek(tmpFd,programHeader[i].phOffset,0);
      fread((void *)programHeader[i].phVaddr,programHeader[i].phFilesz,1,tmpFd);
      }
    else if (programHeader[i].phType == 3) {
      ldAddr = ldEnable();
      }
    }

  if (elfDynamicS != 0x0) {
    for (i=0;i<12;i++) {
      if (elfDynamicS[i].dynVal == 0x3) {
        tmp = (uInt32 *)elfDynamicS[i].dynPtr;
        if (tmp == 0x0)
          kpanic("tmp: NULL\n");
        tmp[2] = (uInt32)ldAddr;
        tmp[1] = (uInt32)tmpFd;
        break;
        }
      }
    }

  /* Adjust iframe */
  tmp = (uInt32 *)_current->tss.esp0 - 5;
  tmp[0] = binaryHeader->eEntry;
  tmp[3] = 0x5DD000-12;
  tmp = (uInt32 *)0x5DD000 - 2;
  tmp[0] = argc;
  tmp[1] = (uInt32)argv;
  
 /* Now That We Relocated The Binary We Can Unmap And Free Header Info */
  kfree(binaryHeader);
  kfree(programHeader);

  return;
  }

/***
 END
 ***/
